<?php
use \Elementor\Widget_Base;
use \Elementor\Controls_Manager;
use \Elementor\Group_Control_Typography;
use \Elementor\Utils;
use \Elementor\Repeater;
use \Elementor\Group_Control_Image_Size;
/**
 *
 * Testimonial Slider Widget .
 *
 */
class haarmax_New_Testimonial_Slider extends Widget_Base{

	public function get_name() {
		return 'haarmaxnewtestimonialslider';
	}

	public function get_title() {
		return __( 'New Testimonial Slider', 'haarmax' );
	}

	public function get_icon() {
		return 'eicon-code';
    }

	public function get_categories() {
		return [ 'haarmax' ];
	}

	protected function register_controls() {

		$this->start_controls_section(
			'testimonial_slider_section',
			[
				'label' 	=> __( 'Testimonial Slider', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_CONTENT,
			]
		);

		$this->add_control(
			'quote_image',
			[
				'label' 		=> __( 'Quote Image', 'haarmax' ),
				'type' 			=> Controls_Manager::MEDIA,
				'default' 		=> [
					'url' 	=> Utils::get_placeholder_image_src(),
				],
			]
		);
		$this->add_control(
			'image',
			[
				'label' 		=> __( 'Choose Image', 'haarmax' ),
				'type' 			=> Controls_Manager::MEDIA,
				'default' 		=> [
					'url' 	=> Utils::get_placeholder_image_src(),
				],
			]
		);
		$repeater = new Repeater();

		$repeater->add_control(
			'client_name', [
				'label' 		=> __( 'Client Name', 'haarmax' ),
				'type' 			=> Controls_Manager::TEXTAREA,
				'default' 		=> __( 'Rosalina D. William' , 'haarmax' ),
				'label_block' 	=> true,
			]
        );
		$repeater->add_control(
			'client_designation', [
				'label' 		=> __( 'Client Designation', 'haarmax' ),
				'type' 			=> Controls_Manager::TEXTAREA,
				'default' 		=> __( 'Customer' , 'haarmax' ),
				'label_block' 	=> true,
			]
        );
        $repeater->add_control(
			'client_feedback_title', [
				'label' 		=> __( 'Client Feedback Title', 'haarmax' ),
				'type' 			=> Controls_Manager::TEXTAREA,
				'default' 		=> __( 'The night was so exicted with full of satisfication with a good service and food.' , 'haarmax' ),
				'label_block' 	=> true,
			]
		);
        $repeater->add_control(
			'client_feedback_description', [
				'label' 		=> __( 'Client Feedback Description', 'haarmax' ),
				'type' 			=> Controls_Manager::TEXTAREA,
				'default' 		=> __( 'Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip ex ea commodo consequat.' , 'haarmax' ),
				'label_block' 	=> true,
			]
		);
		$repeater->add_control(
			'client_image',
			[
				'label' 		=> __( 'Client Image', 'haarmax' ),
				'type' 			=> Controls_Manager::MEDIA,
				'default' 		=> [
					'url' => Utils::get_placeholder_image_src(),
				],
			]
        );
		$this->add_control(
			'slides',
			[
				'label' 		=> __( 'Slides', 'haarmax' ),
				'type' 			=> Controls_Manager::REPEATER,
				'fields' 		=> $repeater->get_controls(),
				'default' 		=> [
					[
						'client_name' 		=> __( 'Rosalina D. William', 'haarmax' ),
						'client_feedback' 	=> __( 'Etiam convallis elementum sapien, a aliquam turpis aliquam vitae.', 'haarmax' ),
						'client_image' 		=> Utils::get_placeholder_image_src(),
					],
					[
						'client_name' 		=> __( 'Rosalina D. William', 'haarmax' ),
						'client_feedback' 	=> __( 'Etiam convallis elementum sapien, a aliquam turpis aliquam vitae.', 'haarmax' ),
						'client_image' 		=> Utils::get_placeholder_image_src(),
					],
					[
						'client_name' 		=> __( 'Rosalina D. William', 'haarmax' ),
						'client_feedback' 	=> __( 'Etiam convallis elementum sapien, a aliquam turpis aliquam vitae.', 'haarmax' ),
						'client_image' 		=> Utils::get_placeholder_image_src(),
					],
				],
				'title_field' 	=> '{{{ client_name }}}',
			]
		);

		$this->end_controls_section();

		$this->start_controls_section(
			'testimonial_general',
			[
				'label' 	=> __( 'General', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_STYLE,
			]
        );

		$this->add_control(
			'quote_icon_color',
			[
				'label' 		=> __( 'Quote Icon Color', 'haarmax' ),
				'type' 			=> Controls_Manager::COLOR,
				'selectors' 	=> [
					'{{WRAPPER}} .quote-icon-style1,{{WRAPPER}} .vs-testimonial-layout3 .icon-quote' => 'color: {{VALUE}}',
				],
			]
        );

		$this->add_control(
			'quote_icon_ropund_bg_color',
			[
				'label' 		=> __( 'Quote Icon Round Shape Background Color', 'haarmax' ),
				'type' 			=> Controls_Manager::COLOR,
				'selectors' 	=> [
					'{{WRAPPER}} .quote-icon-style1:before' => 'background-color: {{VALUE}}',
				],
			]
        );

		$this->add_control(
			'quote_icon_bottom_bg_color',
			[
				'label' 		=> __( 'Quote Icon Bottom Shape Background Color', 'haarmax' ),
				'type' 			=> Controls_Manager::COLOR,
				'selectors' 	=> [
					'{{WRAPPER}} .quote-icon-style1:after'  => 'background-color: {{VALUE}}',
				],
			]
        );
		$this->end_controls_section();

        $this->start_controls_section(
			'testimonial_slider_client_name_style_section',
			[
				'label' 	=> __( 'Client Name', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_STYLE,
			]
        );

        $this->add_control(
			'testimonial_slider_client_name_color',
			[
				'label' 		=> __( 'Client Name Color', 'haarmax' ),
				'type' 			=> Controls_Manager::COLOR,
				'selectors' 	=> [
					'{{WRAPPER}} .author-content .name,{{WRAPPER}} .author-name' => 'color: {{VALUE}}',
				],
			]
        );

        $this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' 		=> 'testimonial_slider_client_name_typography',
				'label' 	=> __( 'Client Name Typography', 'haarmax' ),
				'selector' 	=> '{{WRAPPER}} .author-content .name,{{WRAPPER}} .author-name',
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_name_margin',
			[
				'label' 		=> __( 'Client Name Margin', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .author-content .name,{{WRAPPER}} .author-name' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_name_padding',
			[
				'label' 		=> __( 'Client Name Padding', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .author-content .name,{{WRAPPER}} .author-name' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ]
			]
		);

        $this->end_controls_section();

		$this->start_controls_section(
			'testimonial_slider_designation_style_section',
			[
				'label' 	=> __( 'Designation', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_STYLE,
			]
        );

        $this->add_control(
			'testimonial_slider_designation_color',
			[
				'label' 	=> __( 'Client Designation Color', 'haarmax' ),
				'type' 		=> Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .author-content .designation,{{WRAPPER}} .vs-testimonial-layout3 .degi,{{WRAPPER}} .testimonial-content .author-name .designation' => 'color: {{VALUE}}',
				],
			]
        );

        $this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' 		=> 'testimonial_slider_designation_typography',
				'label' 	=> __( 'Client Designation Typography', 'haarmax' ),
				'selector' 	=> '{{WRAPPER}} .author-content .designation,{{WRAPPER}} .vs-testimonial-layout3 .degi,{{WRAPPER}} .testimonial-content .author-name .designation',
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_designation_margin',
			[
				'label' 		=> __( 'Client Designation Margin', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .author-content .designation,{{WRAPPER}} .vs-testimonial-layout3 .degi,{{WRAPPER}} .testimonial-content .author-name .designation' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_designation_padding',
			[
				'label' 		=> __( 'Client Designation Padding', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .author-content .designation,{{WRAPPER}} .vs-testimonial-layout3 .degi,{{WRAPPER}} .testimonial-content .author-name .designation' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ]
			]
		);

        $this->end_controls_section();

        $this->start_controls_section(
			'testimonial_slider_client_feedback_style_section',
			[
				'label' 	=> __( 'Client Feedback Title', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_STYLE,
			]
        );

        $this->add_control(
			'testimonial_slider_client_feedback_color',
			[
				'label' 	=> __( 'Client Feedback Title Color', 'haarmax' ),
				'type' 		=> Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .testimonial-content .title' => 'color: {{VALUE}}',
				],
			]
        );

        $this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' 		=> 'testimonial_slider_client_feedback_typography',
				'label' 	=> __( 'Client Feedback Title Typography', 'haarmax' ),
				'selector' 	=> '{{WRAPPER}} .testimonial-content .title',
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_feedback_margin',
			[
				'label' 		=> __( 'Client Feedback Title Margin', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .testimonial-content .title' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_feedback_padding',
			[
				'label' 		=> __( 'Client Feedback Title Padding', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .testimonial-content .title' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ]
			]
		);

        $this->end_controls_section();

        $this->start_controls_section(
			'testimonial_slider_client_feedback_description_style_section',
			[
				'label' 	=> __( 'Client Feedback Description', 'haarmax' ),
				'tab' 		=> Controls_Manager::TAB_STYLE,
			]
        );

        $this->add_control(
			'testimonial_slider_client_feedback_description_color',
			[
				'label' 	=> __( 'Client Feedback Description Color', 'haarmax' ),
				'type' 		=> Controls_Manager::COLOR,
				'selectors' => [
					'{{WRAPPER}} .testimonial-content .description,{{WRAPPER}} .testi-text,{{WRAPPER}} .testimonial-content .description' => 'color: {{VALUE}}',
				],
			]
        );

        $this->add_group_control(
			Group_Control_Typography::get_type(),
			[
				'name' 		=> 'testimonial_slider_client_feedback_description_typography',
				'label' 	=> __( 'Client Feedback Description Typography', 'haarmax' ),
				'selector' 	=> '{{WRAPPER}} .testimonial-content .description,{{WRAPPER}} .testi-text,{{WRAPPER}} .testimonial-content .description',
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_feedback_description_margin',
			[
				'label' 		=> __( 'Client Feedback Description Margin', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .testimonial-content .description,{{WRAPPER}} .testi-text,{{WRAPPER}} .testimonial-content .description' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ],
			]
        );

        $this->add_responsive_control(
			'testimonial_slider_client_feedback_description_padding',
			[
				'label' 		=> __( 'Client Feedback Description Padding', 'haarmax' ),
				'type' 			=> Controls_Manager::DIMENSIONS,
				'size_units' 	=> [ 'px', '%', 'em' ],
				'selectors' 	=> [
					'{{WRAPPER}} .testimonial-content .description,{{WRAPPER}} .testi-text,{{WRAPPER}} .testimonial-content .description' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
                ]
			]
		);

        $this->end_controls_section();




	}

	protected function render() {

		$settings = $this->get_settings_for_display();

	    $this->add_render_attribute( 'wrapper', 'class', 'row justify-content-center' );

		if( !empty( $settings['slides'] ) ){
			echo '<div class="vs-testimonial-wrapper">';
			  	echo '<div class="container z-index-common">';
					echo '<div '.$this->get_render_attribute_string( 'wrapper' ).'>';
                        if( ! empty( $settings['quote_image']['url'] ) ){
    						echo '<div class="col-12 text-center">';
    		                    echo '<span class="quote-icon-style1 has-white-shape">';
                                    echo haarino_img_tag( array(
                                        'url'   => esc_url( $settings['quote_image']['url'] ),
                                    ) );
                                echo '</span>';
    		                echo '</div>';
                        }
						echo '<div class="col-xl-10">';
							echo '<div class="testimonial-content-area text-center vs-carousel" id="testi-content" data-arrows="false" data-fade="true" data-asnavfor="#testi-author-name, #testi-author" data-slidetoshow="1" data-mdslidetoshow="1">';
								foreach( $settings['slides'] as $singleslide ) {
			                        echo '<div class="testimonial-content px-xl-5">';
			                            echo '<h2 class="title text-white">'.wp_kses_post( $singleslide['client_feedback_title'] ).'</h2>';
			                            echo '<p class="text-20 description text-white">'.wp_kses_post( $singleslide['client_feedback_description'] ).'</p>';
			                        echo '</div>';
								}
							echo '</div>';
						echo '</div>';
						echo '<div class="col-xl-3">';
							echo '<div class="testimonial-author-style1 text-center" id="testi-author-name" data-fade="true" data-asnavfor="#testi-content, #testi-author" data-slidetoshow="1">';
								foreach( $settings['slides'] as $singleslide ) {
									echo '<div class="author-content">';
										if( ! empty( $singleslide['client_name'] ) ){
											echo '<h3 class="name h4 mb-0 text-white">'.esc_html( $singleslide['client_name'] ).'</h3>';
										}
										if( ! empty( $singleslide['client_designation'] ) ){
											echo '<span class="designation mb-0 text-bold text-white">'.esc_html( $singleslide['client_designation'] ).'</span>';
										}
									echo '</div>';
								}
							echo '</div>';
						echo '</div>';

						if( ! empty( $settings['image']['url'] ) ){
							echo '<div class="col-12">';
			                    echo '<div class="testimonial-border-line text-center mb-2">';
									echo haarino_img_tag( array(
										'url'	=> esc_url( $settings['image']['url'] )
									) );
			                    echo '</div>';
			                echo '</div>';
						}
						echo '<div class="col-xl-12">';
							echo '<div class="testimonial-avater-style1" id="testi-author" data-asnavfor="#testi-author-name, #testi-content" data-slidetoshow="3" data-centermode="true" data-variablewidth="true">';
								foreach( $settings['slides'] as $singleslide ) {
									if( ! empty( $singleslide['client_image']['url'] ) ){
										echo '<div class="author-img">';
											echo haarino_img_tag( array(
												'url'	=> esc_url( $singleslide['client_image']['url'] ),
												'class'	=> 'w-100',
											) );
										echo '</div>';
									}
								}
							echo '</div>';
						echo '</div>';

					echo '</div><!-- .row END -->';
				echo '</div>';
			echo '</div>';
		}

	}

}