<?php

/**
 * @Packge     : Haarmax
 * @Version    : 1.0
 * @Author     : Vecurosoft
 * @Author URI : https://www.vecurosoft.com/
 *
 */

    // Block direct access

    if( ! defined( 'ABSPATH' ) ){

        exit();

    }

/**

 * Admin Custom Login Logo

 */

function haarmax_custom_login_logo() {

    $logo = ! empty( haarino_opt( 'haarmax_admin_login_logo', 'url' ) ) ? haarino_opt( 'haarmax_admin_login_logo', 'url' ) : '' ;

    if( isset( $logo ) && ! empty( $logo ) ){

        echo '<style type="text/css">body.login div#login h1 a { background-image:url('.esc_url( $logo ).'); }</style>';
    }
}

add_action( 'login_enqueue_scripts', 'haarmax_custom_login_logo' );

/**
* Admin Custom css
*/

add_action( 'admin_enqueue_scripts', 'haarmax_admin_styles' );

function haarmax_admin_styles() {

  if ( ! empty( $haarmax_admin_custom_css ) ) {
        $haarmax_admin_custom_css = str_replace(array("\r\n", "\r", "\n", "\t", '    '), '', $haarmax_admin_custom_css);
        echo '<style rel="stylesheet" id="haarmax-admin-custom-css" >';
            echo esc_html( $haarmax_admin_custom_css );
        echo '</style>';
    }
}

 // share button code

 function haarino_social_sharing_buttons( ) {

    // Get page URL

    $URL        = get_permalink();
    $Sitetitle  = get_bloginfo('name');
    // Get page title

    $Title  = str_replace( ' ', '%20', get_the_title());

    // Construct sharing URL without using any script

    $twitterURL     = 'https://twitter.com/share?text='.esc_html( $Title ).'&url='.esc_url( $URL );

    $facebookURL    = 'https://www.facebook.com/sharer/sharer.php?u='.esc_url( $URL );

    $pinteresturl   = 'http://pinterest.com/pin/create/link/?url='.esc_url( $URL ).'&media='.esc_url(get_the_post_thumbnail_url()).'&description='.wp_kses_post(get_the_title());

    $linkedin       = 'https://www.linkedin.com/shareArticle?mini=true&url='.esc_url( $URL ).'&title='.esc_html( $Title );

    // Add sharing button at the end of page/page content

    $content = '';

    $content .= '<li><a class="facebook" href="'.esc_url( $facebookURL ).'" target="_blank"><i class="fab fa-facebook-f"></i></a></li>';

    $content .= '<li><a class="twitter" href="'. esc_url( $twitterURL ) .'" target="_blank"><i class="fab fa-twitter"></i></a></li>';

    $content .= '<li><a class="pinterest" href="'.esc_url( $pinteresturl ).'" target="_blank"><i class="fab fa-pinterest"></i></a></li>';

    $content .= '<li><a class="linkedin" href="'.esc_url( $linkedin ).'" target="_blank"><i class="fab fa-linkedin-in"></i></a></li>';

    return $content;

};



//add SVG to allowed file uploads

function haarmax_mime_types( $mimes ) {

    $mimes['svg'] = 'image/svg+xml';
    $mimes['svgz'] = 'image/svgz+xml';
    $mimes['exe'] = 'program/exe';
    $mimes['dwg'] = 'image/vnd.dwg';
    return $mimes;

}

add_filter('upload_mimes', 'haarmax_mime_types');



function haarmax_wp_check_filetype_and_ext( $data, $file, $filename, $mimes ) {

    $wp_filetype = wp_check_filetype( $filename, $mimes );
    $ext         = $wp_filetype['ext'];
    $type        = $wp_filetype['type'];
    $proper_filename = $data['proper_filename'];

    return compact( 'ext', 'type', 'proper_filename' );

}

add_filter( 'wp_check_filetype_and_ext', 'haarmax_wp_check_filetype_and_ext', 10, 4 );


/**
* Enqueue block editor JavaScript and CSS
*/
function haarmax_widget_editor_scripts() {

    // Make paths variables so we don't write em twice 😉
    $blockPath = '../assets/js/blocks.js';

    // Enqueue the bundled block JS file
    wp_enqueue_script(
        'haarmax-blocks-js',
        plugins_url( $blockPath, __FILE__ ),
        [  'wp-blocks', 'wp-element', 'wp-components', 'wp-i18n' ],
        '1.00',
        true
    );

}
// Hook scripts function into block editor hook
add_action( 'enqueue_block_editor_assets', 'haarmax_widget_editor_scripts' );

// Add Image Size

add_filter('wpcf7_autop_or_not', '__return_false');
add_image_size( 'haarmax_150X170', 150, 170, true );
add_image_size( 'haarmax_90X80', 90, 80, true );
add_image_size( 'home-slider-blog-image', 374, 313, true );
add_image_size( 'home-slider-blog-image-two', 470, 270, true );
add_image_size( 'blog-post-image-three', 370, 214, true );